# CBD Simulator Development Kit

## Prerequisites

The following describes the pre-requisites to running the tests and completing the assignment.

It is recommended to first run the tests and the example described in the assignment, just to make sure that you need to install the following. Most distributions of python will already come with Bokeh and/or Graphviz.

The code has been tested in Python `3.6.8`.

For plotting, the code uses the Bokeh library. To install bokeh for python, follow the instructions in: <https://bokeh.pydata.org/en/latest/docs/user_guide/quickstart.html#installation>

For rendering CBDs, the code uses the Graphviz library. To install Graphviz, follow the steps:

1. Download and install Graphviz: <https://www.graphviz.org/download/>
1. Make sure the Graphviz binaries are accessible in the PATH environment variable. For example, on windows there should be an entry in the PATH with: `C:\Graphviz2.38\bin`
1. Install graphviz for python: <https://graphviz.readthedocs.io/en/stable/manual.html>
   1. Note: for anaconda users, use <https://anaconda.org/anaconda/graphviz>

## Running Tests

Open command line in this directory, and run:

```
/path/to/python3/python -m unittest discover -s ./cbd/test
```

For example:

```
C:\Anaconda3\python.exe -m unittest discover -s ./cbd/test
```

## Running the Example

Open command line in this directory, and run:

```
/path/to/python3/python -m cbd.examples.EvenNumbersCBD
```

For example:

```
C:\Anaconda3\python.exe -m cbd.examples.EvenNumbersCBD
```

This will generate and open three pdfs and an html file in the local dir.

